package com.liang.dao;

import com.liang.entity.PrjSubtopicplan;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (PrjSubtopicplan)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-05 09:15:19
 */
public interface PrjSubtopicplanDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjSubtopicplan queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjSubtopicplan 查询条件
     * @param pageable        分页对象
     * @return 对象列表
     */
    List<PrjSubtopicplan> queryAllByLimit(PrjSubtopicplan prjSubtopicplan, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjSubtopicplan 查询条件
     * @return 总行数
     */
    long count(PrjSubtopicplan prjSubtopicplan);

    /**
     * 新增数据
     *
     * @param prjSubtopicplan 实例对象
     * @return 影响行数
     */
    int insert(PrjSubtopicplan prjSubtopicplan);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjSubtopicplan> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjSubtopicplan> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjSubtopicplan> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjSubtopicplan> entities);

    /**
     * 修改数据
     *
     * @param prjSubtopicplan 实例对象
     * @return 影响行数
     */
    int update(PrjSubtopicplan prjSubtopicplan);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取子课题计划
     *
     * @param zkt
     * @return
     */
    List<PrjSubtopicplan> getSubtopicPlanList(Integer zkt);

    /**
     * 通过子课题删除数据
     *
     * @param zkt
     * @return
     */
    int deleteByZkt(Integer zkt);

    /**
     * 批量删除子课题计划
     *
     * @param zktList
     * @return
     */
    int batchDeleteByZkt(List<Integer> zktList);

    /**
     * 批量删除子课题计划
     *
     * @return
     */
    int deleteByXm(Integer xm);

    int batchDeleteByXm(List<Integer> xmList);
}

